#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers
// Windows Header Files
#include <windows.h>

#ifndef _DEBUG
#pragma comment(linker, "/ENTRY:DllMain")
//#pragma comment(lib, "ntdllp.lib")
#endif
HANDLE heap;

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved) {
    if (ul_reason_for_call == DLL_PROCESS_ATTACH) {
        DisableThreadLibraryCalls(hModule);
        heap = GetProcessHeap();
    }
    return true;
}

void* __cdecl operator new (size_t size) {
    return (void*)HeapAlloc(heap, 0, size);
}

void __declspec(noinline) __cdecl operator delete(void* ptr, size_t size) {
    if (!HeapValidate(heap, 0, ptr)) {
        MessageBoxA(0, "Heap corrupt or Invalid ptr.", "ERROR", MB_ICONERROR | MB_OK | MB_TOPMOST | MB_SETFOREGROUND);
    }
    else if (HeapSize(heap, 0, ptr) != size) {
        MessageBoxA(0, "Wrong memory size specified when calling operator delete.", "ERROR", MB_ICONERROR | MB_OK | MB_TOPMOST | MB_SETFOREGROUND);
    }
    else {
        HeapFree(heap, 0, ptr);
    }
}

void __declspec(noinline) __cdecl operator delete(void* ptr) {
    if (!HeapValidate(heap, 0, ptr)) {
        MessageBoxA(0, "Heap corrupt or Invalid ptr.", "ERROR", MB_ICONERROR | MB_OK | MB_TOPMOST | MB_SETFOREGROUND);
    }
    HeapFree(heap, 0, ptr);
}


#include <intrin.h>

extern "C" int __cdecl _purecall() {
    DWORD_PTR r = (DWORD_PTR)_ReturnAddress();
    RaiseException(STATUS_ACCESS_VIOLATION, EXCEPTION_NONCONTINUABLE, 1, &r);
    return 0;
}

class type_info {
    virtual ~type_info();
};

type_info::~type_info() {
    _purecall();
}
